#define STRSIZ		1024

#define free_it(x)		{if(x){free(x);x=NULL;}}
#define STRNCMP(x,y)		(strncmp(x,y,strlen(y)))
#define STRNCASECMP(x,y)	(strncasecmp(x,y,strlen(y)))
#define SKIP(s,set)		while((*s)&&(strchr(set,*s)))s++;
#define SKIPN(s,set)		while((*s)&&(!strchr(set,*s)))s++;
#define STREND(s)		(s+strlen(s))
#define STRNCPY(x,y)		{strncpy(x,y,sizeof(x));x[sizeof(x)-1]=0;}

#define ORD_RATE	1
#define ORD_DATE	2

#define MOD_ALL		1
#define MOD_ANY		2


typedef struct word_struct {
	int count;
	char *word;
} UDM_WORD;

typedef struct href_struct {
	char *href;
	int referrer;
	int hops;
	int stored;
} HREF;

typedef struct robots_struct {
	char *hostinfo;
	char *path;
} ROBOT;

typedef struct stat_struct {
	int status;
	int expired;
	int total;
} STAT;

typedef struct server_struct {
	char *url;
	char *charset;
	char *proxy;
	char *basic_auth;
	int  proxy_port;
	int  period;
	int  hint;
	int  net_errors;
	int  max_net_errors;
	int  read_timeout;
	int  outside;
	int  maxhops;
	int  gindex;
	int  gfollow;
	int  deletebad;
	int  userobots;
	int  bodyweight;
	int  titleweight;
	int  urlweight;
	int  descweight;
	int  keywordweight;
} SERVER;


typedef struct url_struct {
	int	url_id;
	int	status;
	char	*url;
	char	*content_type;
	char	*last_modified;
	char	*title;
	char 	*text;
	int	size;
	char	*last_index_time;
	char	*next_index_time;
	int	referrer;
	int	tag;
	int	hops;
	char	*keywords;
	char	*description;
	char	*crc;
	int	rating;
} DOCUMENT;

