#ifdef HAVE_MYSQL
#define ER_DUP_ENTRY            1062
#define CR_SERVER_LOST          2013
#define CR_SERVER_GONE_ERROR    2006
#define ER_SERVER_SHUTDOWN      1053
#endif

extern char DBVersion[];
extern char *DBHost;
extern char *DBName;
extern char *DBUser;
extern char *DBPass;
extern int  DBPort;
extern int  DbExitOnError;
extern int  DbLastErrorCode;


char  **  LoadStopList();
extern int AddURL(char *url,int referrer,int hops);
extern int DeleteWordFromURL(int url_id);
extern int DeleteUrl(int url_id);
extern int UpdateUrl(int url_id,int status,int period);
extern char * escstr(char *x,char *y);

extern int LongUpdateUrl(
	int url_id,int status,int is_changed,
	int size,int period,int hint,int index,
	char *last_modified_escaped,
	char *text_escaped,
	char *title_escaped,
	char *content_type,
	char *keywords_escaped,
	char *descript_escaped,
	char *digest);

extern int StoreWords(int url_id, int wcur,UDM_WORD *Word);
extern int StoreHrefs(int hcur,HREF *Href);
extern ROBOT * LoadRobots();
extern int FindOrigin(char *crc);
extern int MarkClone(int url_id,int status,int period,
	char *content_type,char *last_modified_escaped,char *digest);

extern int DeleteAllFromDict();
extern int DeleteAllFromUrl();

extern void abort_indexer();
extern int exit_nicely(int c);

extern int ShowReferers();
extern STAT * GetStatistics();
extern int ClearDatabase();
extern int MarkForReindex();

DOCUMENT *GetDocInfo(int gmt_offset,int expired_first);

extern int AddSpell(char *flag,char *lang,char *word);
extern int AddAffix(char *flag,char *lang,char *mask,char *find,char *repl,char *type);

extern int DeleteRobotsFromHost(char *hostinfo);
extern int AddRobotsToHost(char *hostinfo,char *s);

extern char ** GetAllWordForms(char *word);
extern DOCUMENT * Find(char *q,int np,int ps, int mode,int sort_order,char *wordinfo,int *found);
extern char * DBErrorMsg();

extern int AddTagLimit(int tag);
extern int AddStatusLimit(int status);
extern int AddURLLimit(char *URL);
extern DOCUMENT * CloneList(char *crc);
extern int IsStopWord(char *word);
