#define BASE64_LEN(len) (4 * (((len) + 2) / 3) +2)

#define HTTP_STATUS_UNKNOWN		0
#define HTTP_STATUS_OK			200
#define HTTP_STATUS_REDIRECT		301
#define HTTP_STATUS_NOT_MODIFIED	304
#define HTTP_STATUS_DELETE		400
#define HTTP_STATUS_RETRY		503

extern void base64_encode (const char *s, char *store, int length);

extern int open_host(char *hostname,int port,int timeout);

extern int HTTPResponseType(int status);

extern char *HTTPErrMsg(int code);

extern int HTTPGet(char *host,int port,char *header,
	char *dist,int maxsize,int read_timeout);

extern int FILEGet(char *header,char *dist,int maxsize);

extern int NEWSGet(char *host,int port,char *header,
	char *dist,int maxsize,int read_timeout);
	
extern int NNTPGet(char *host,int port,char *header,
	char *dist,int maxsize,int read_timeout);

extern int AddType(char *mime_type,char *reg);
